BITS 32

        ;**********************************************
        ;*                 CONSTANTES                 *
        ;**********************************************
        
_pushad     equ 0x20
_eax        equ 0x1C 

        ;**********************************************
        ;*                   MACROS                   *
        ;**********************************************  
              
%define prologue esp+_pushad+4

        ;**********************************************
        ;*                 STRUCTURES                 *
        ;**********************************************
        
struc CWPSTRUCT
    .lParam:  resd 1
    .wParam:  resd 1
    .message: resd 1
    .hwnd:    resd 1
endstruc
SIZE_OF_MSG equ (4*4) 

        ;**********************************************
        ;*                   EXPORTS                  *
        ;**********************************************

GLOBAL Set_Handle_Hook
export Set_Handle_Hook

GLOBAL HookProc
export HookProc

        ;**********************************************
        ;*                  IMPORTS                   *
        ;**********************************************   

; -----------
;   User32
; -----------

extern FindWindowA
import FindWindowA user32.dll

extern CallNextHookEx
import CallNextHookEx user32.dll

extern InvalidateRect
import InvalidateRect user32.dll

extern UpdateWindow
import UpdateWindow user32.dll

 ; ------------------------------------------------------------------------------
 ; ------------------------------------------------------------------------------
  SEGMENT code USE32
 ; ------------------------------------------------------------------------------
 ; ------------------------------------------------------------------------------

        ;**********************************************
        ;*                    DATA                    *
        ;**********************************************
        
handle_window_hook  dd 0
fo1_window_class    db 'GNW95 Class',0
fo1_window_name     db 'FALLOUT',0

        ;**********************************************
        ;*                    CODE                    *
        ;**********************************************

;*****************************
;* Fonction d'initialisation *
;*****************************************************************************
; BOOL APIENTRY DllMain( HINSTANCE hModule, DWORD raison, LPVOID lpReserved) *
;*****************************************************************************
..start:
  xor eax,eax
  inc eax
  ret (3*4)
;*****************************************************************************
;*****************************************************************************

HookProc :
; LRESULT CALLBACK GCallWndProc(
;     int code,         // hook code
;     WPARAM wParam,    // info proc event
;     LPARAM lParam     // address of structure with message
;    );

    xor eax,eax
    pushad     
    mov esi, [prologue]       ; hook code
    mov edi, [prologue+8]     ; address of structure with message   
    
    cmp esi,0
    jge .traitement
     
    push dword [edi+CWPSTRUCT.lParam]
    push dword [edi+CWPSTRUCT.wParam]
    push esi
    push dword [handle_window_hook]
    call [CallNextHookEx]
    mov [esp+_eax], eax
    jmp .sortie

.traitement :
    
    lea eax, [fo1_window_name]
    push eax
    lea eax, [fo1_window_class]
    push eax
    call [FindWindowA]
    mov ebp, eax
    or eax,eax
    je .sortie          
        
.verif_fenetre :
    ; vrifier si nous avons  faire  un message adress
    ;  la fentre de Fallout
    cmp ebp, [edi+CWPSTRUCT.hwnd]
    jne .sortie 

    ;-----------------------------
    ; Traiter tous les messages
    ;-----------------------------        
    push 0
    push 0
    push ebp
    call [InvalidateRect]
        
    push ebp
    call [UpdateWindow]       
.sortie :
    popad
    ret (3*4)
    
;*****************************************************************************
;*****************************************************************************    

Set_Handle_Hook :
  mov eax,[esp+4]
  mov [handle_window_hook], eax
  ret 4
  
;*****************************************************************************
;*****************************************************************************

